package com.denizenscript.clientizen.mixin;

import com.denizenscript.clientizen.events.KeyPressReleaseScriptEvent;
import it.unimi.dsi.fastutil.ints.IntArraySet;
import it.unimi.dsi.fastutil.ints.IntSet;
import net.minecraft.class_304;
import net.minecraft.class_3675;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_304.class)
public class KeyBindingMixin {

    private static final IntSet pressedKeys = new IntArraySet();

    @Inject(method = "setKeyPressed", at = @At("HEAD"))
    private static void clientizen$onKeyPressStateChanged(class_3675.class_306 key, boolean pressed, CallbackInfo ci) {
        if (key.method_1442() == class_3675.class_307.field_1668 || key.method_1442() == class_3675.class_307.field_1672) {
            if (!pressed || !pressedKeys.contains(key.method_1444())) {
                KeyPressReleaseScriptEvent.instance.handleKeyPressStateChange(key, pressed);
            }
            if (pressed) {
                pressedKeys.add(key.method_1444());
            }
            else {
                pressedKeys.remove(key.method_1444());
            }
        }
    }
}
